//
//  WebViewDelegate.h
//
// ADOBE SYSTEMS INCORPORATED
// Copyright 2014 Adobe Systems Incorporated
// All Rights Reserved.
//
// NOTICE:  Adobe permits you to use, modify, and distribute this file in accordance with the
// terms of the Adobe license agreement accompanying it.  If you have received this file from a
// source other than Adobe, then your use, modification, or distribution of it requires the prior
// written permission of Adobe.
//

#import <Foundation/Foundation.h>
#import "WebViewInterface.h"

@interface WebViewDelegate : NSObject <UIWebViewDelegate>
	@property UIWebView* webView;

	- (id)initWithWebView:(UIWebView*) webView withWebViewInterface:(id<WebViewInterface>) webViewInterface;
	- (void) loadPage:(NSString*) pageName fromFolder:(NSString*) folderName;
	- (void) createError:(NSError**) error withCode:(int) code withMessage:(NSString*) msg;
	- (void) callJSFunction:(NSString *) name withArgs:(NSDictionary *) args;

@end

